// InfoListCtrl.h: interface for the CInfoListCtrl class.
// (p) 2002 by FoRcHa (a.k.a. NO)  [seppforcher38@hotmail.com]
//////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_INFOLISTCTRL_H__3BAB23B2_6ED7_47E7_A3E6_8ECE3FA6D42C__INCLUDED_)
#define AFX_INFOLISTCTRL_H__3BAB23B2_6ED7_47E7_A3E6_8ECE3FA6D42C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "COPTIONTREE\OptionTree.h"
#include "types.h"
#include "updownclient.h"

class CInfoListCtrl : public COptionTree  
{
public:
	CInfoListCtrl();
	virtual ~CInfoListCtrl();
	void Localize();

protected:
	void FillSourcenameList();
	void ReCreateList(BOOL bUserData);
	void UpdateData(bool bRedraw = true, bool bExpand = false);
	void SaveState(bool bUser)
	{
		if(bUser)
		{
			if(m_client != NULL && !m_bClear)
			{
				if(UserData.General)
					m_bExpandedUser[0] = UserData.General->IsExpanded();
				if(UserData.Transfer)
					m_bExpandedUser[1] = UserData.Transfer->IsExpanded();
				if(UserData.Scores)
					m_bExpandedUser[2] = UserData.Scores->IsExpanded();
				if(UserData.RemoteScores)
					m_bExpandedUser[3] = UserData.Scores->IsExpanded();
			}
		}
		else
		{
			if(m_file != NULL)
			{
				if(FileData.General)
					m_bExpandedFile[0] = FileData.General->IsExpanded();
				if(FileData.Transfer)
					m_bExpandedFile[1] = FileData.Transfer->IsExpanded();
			}
		}
	}

protected:
	CPartFile* m_file;
	CUpDownClient* m_client;
	bool m_bUser;
	bool m_bClear;

	UINT m_nUpdateTimer;
	COLORREF m_crEntryTextColor;

	bool m_bExpandedUser[4];
	bool m_bExpandedFile[2];
	
	struct _TAG_USERDATA_
	{
		COptionTreeItem			*General;
		COptionTreeItemStatic	*UserName;
		COptionTreeItemStatic	*UserHash;
		COptionTreeItemStatic	*ClientSoftware;
		COptionTreeItemStatic	*ClientVersion;
		COptionTreeItemStatic	*IPAddress;
		COptionTreeItemStatic	*ID;
		COptionTreeItemStatic	*ServerIP;
		COptionTreeItemStatic	*ServerName;

		COptionTreeItem			*Transfer;
		COptionTreeItemStatic	*CurDownloading;
		COptionTreeItemStatic	*DownloadedSession;
		COptionTreeItemStatic	*UploadedSession;
		COptionTreeItemStatic	*AverageDownloadrate;
		COptionTreeItemStatic	*AverageUploadrate;
		COptionTreeItemStatic	*DownloadedTotal;
		COptionTreeItemStatic	*UploadedTotal;

		COptionTreeItem			*Scores;
		COptionTreeItemStatic	*DlUpModifier;
		COptionTreeItemStatic	*CommunityUser;
		COptionTreeItemStatic	*Rating;
		COptionTreeItemStatic	*UploadQueueScore;

        // Maverick
		COptionTreeItemStatic	*SFRatio;
		COptionTreeItemStatic	*RFRatio;

		COptionTreeItem			*RemoteScores;
		COptionTreeItemStatic	*RemoteDlUpModifier;
		COptionTreeItemStatic	*RemoteCommunityUser;
		COptionTreeItemStatic	*RemoteRating;
		COptionTreeItemStatic	*RemoteUploadQueueScore;
		COptionTreeItemStatic	*RemoteQueueRank;
		COptionTreeItemStatic	*RemoteClientSpeed;
	
	}UserData;
	
	struct _TAG_FILEDATA_
	{
		COptionTreeItem			*General;
		COptionTreeItemStatic	*FullName;
		COptionTreeItemStatic	*MetFile;
		COptionTreeItemStatic	*Hash;
		COptionTreeItemStatic	*FileSize;
		COptionTreeItemStatic	*PartFileStatus;
		COptionTreeItemComboBox	*SourceNames;
		bool					bSourceNameCombo;
		int						iSourceNameUpdateDelay;
		
		COptionTreeItem			*Transfer;
		COptionTreeItemStatic	*FoundSources;
		COptionTreeItemStatic	*FilepartCount;
		COptionTreeItemStatic	*PartAvailable;
		COptionTreeItemStatic	*Transfered;
		COptionTreeItemStatic	*DataRate;
		COptionTreeItemStatic	*Transfering;
		COptionTreeItemStatic	*CompletedSize;
		COptionTreeItemStatic	*LastSeenComplete;
		COptionTreeItemStatic	*LastProgress;	//SyruS last progress info

	}FileData;

public:
	BOOL Create(DWORD dwStyle, RECT rcRect, CWnd* pParentWnd, UINT nID);

	void SwitchToUser(CUpDownClient* client);
	void SwitchToFile(CPartFile* file);

	int GetType()
	{
		return m_bUser ? (m_client == NULL ? 0 : 1) : (m_file == NULL ? 0 : 2);
	}
	CString GetName()
	{
		if(m_bUser)
			return m_client == NULL ? _T("") : m_client->GetUserName();
		else
			return m_file == NULL ? _T("") : m_file->GetFileName();
	}
	CPartFile* GetFile()
	{
		return m_file;
	}
	CUpDownClient* GetClient()
	{
		return m_client;
	}

protected:
	//{{AFX_MSG(CInfoListCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
};

#endif // !defined(AFX_INFOLISTCTRL_H__3BAB23B2_6ED7_47E7_A3E6_8ECE3FA6D42C__INCLUDED_)
// (p) 2002 by FoRcHa (a.k.a. NO)  [seppforcher38@hotmail.com]
