// Apfelteig Patch ;-)

#include "stdafx.h"
#include "emule.h"
#include "PPgHTTPD.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define HIDDEN_PASSWORD _T("*****")

IMPLEMENT_DYNAMIC(CPPgHTTPD, CPropertyPage)
CPPgHTTPD::CPPgHTTPD()
	: CPropertyPage(CPPgHTTPD::IDD)
	, httpdPort(_T(""))
	, httpdPass(_T(""))
	, httpdPassLow(_T(""))
	, tmplPath(_T(""))
	, httpdEnabled(FALSE)
	, httpdEnabledLow(FALSE)
	, httpdIntruderDetectEnabled(FALSE)
	, tempDisableLogin(_T(""))
	, loginAttemptsAllowed(_T(""))
	, generalDesc(_T(""))
	, adminDesc(_T(""))
	, lowUserDesc(_T(""))
	, intruderDesc(_T(""))
	, adminPassDesc(_T(""))
	, lowUserPassDesc(_T(""))
	, portDesc(_T(""))
	, intrLoginDesc(_T(""))
	, intrTimeDesc(_T(""))
	, intrDisableDesc(_T(""))
{
}

CPPgHTTPD::~CPPgHTTPD()
{
}

void CPPgHTTPD::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_HTTPDPORT, httpdPort);
	DDX_Text(pDX, IDC_HTTPDPASS, httpdPass);
	DDX_Text(pDX, IDC_HTTPDPASSLOW, httpdPassLow);
	DDX_Text(pDX, IDC_TMPLPATH, tmplPath);
	DDX_Check(pDX, IDC_HTTPDENABLED, httpdEnabled);
	DDX_Check(pDX, IDC_HTTPDENABLEDLOW, httpdEnabledLow);
	DDX_Check(pDX, IDC_HTTPDINTRUDERDETECTION, httpdIntruderDetectEnabled);
	DDX_Text(pDX, IDC_HTTPDTEMPDISABLELOGIN, tempDisableLogin);
	DDX_Text(pDX, IDC_HTTPDLOGINATTEMPTSALLOWED, loginAttemptsAllowed);
	DDX_Control(pDX, IDC_HTTPDPORT, httpdPortEdit);
	DDX_Control(pDX, IDC_TMPLPATH, tmplPathEdit);
	DDX_Control(pDX, IDC_HTTPDPASS, httpdPassEdit);
	DDX_Control(pDX, IDC_HTTPDPASSLOW, httpdPassLowEdit);
	DDX_Control(pDX, IDC_HTTPDLOGINATTEMPTSALLOWED, loginAttemptsAllowedEdit);
	DDX_Control(pDX, IDC_HTTPDTEMPDISABLELOGIN, tempDisableLoginEdit);
	DDX_Control(pDX, IDC_TMPLBROWSE, tmplBrowseButton);
	DDX_Control(pDX, IDC_HTTPDINTRUDERDETECTION, intruderDetectionCheck);
	DDX_Control(pDX, IDC_HTTPDRELOADTMPL, httpdReloadTmplButton);
	DDX_Control(pDX, IDC_HTTPDENABLEDLOW, httpdEnabledLowCheck);
	DDX_Text(pDX, IDC_STATIC_GENERAL, generalDesc);
	DDX_Text(pDX, IDC_STATIC_ADMIN, adminDesc);
	DDX_Text(pDX, IDC_STATIC_LOWUSER, lowUserDesc);
	DDX_Text(pDX, IDC_STATIC_INTRUDER, intruderDesc);
	DDX_Control(pDX, IDC_HTTPDENABLED, httpdEnabledCheck);
	DDX_Text(pDX, IDC_HTTPDPASS_LBL, adminPassDesc);
	DDX_Text(pDX, IDC_HTTPDPASS_LBL2, lowUserPassDesc);
	DDX_Text(pDX, IDC_HTTPDPORT_LBL, portDesc);
	DDX_Text(pDX, IDC_INTR_LOGIN, intrLoginDesc);
	DDX_Text(pDX, IDC_INTR_TIME, intrTimeDesc);
	DDX_Text(pDX, IDC_INTR_DISABLE, intrDisableDesc);
}
BEGIN_MESSAGE_MAP(CPPgHTTPD, CPropertyPage)
	ON_EN_CHANGE(IDC_HTTPDPASS, OnDataChange)
	ON_EN_CHANGE(IDC_HTTPDPASSLOW, OnDataChange)
	ON_EN_CHANGE(IDC_HTTPDPORT, OnDataChange)
	ON_EN_CHANGE(IDC_TMPLPATH, OnDataChange)
	ON_BN_CLICKED(IDC_HTTPDENABLED, OnEnChangeHTTPDEnabled)
	ON_BN_CLICKED(IDC_HTTPDENABLEDLOW, OnEnChangeHTTPDEnabled)
	ON_BN_CLICKED(IDC_HTTPDRELOADTMPL, OnReloadTemplates)
	ON_EN_CHANGE(IDC_HTTPDLOGINATTEMPTSALLOWED, OnDataChange)
	ON_EN_CHANGE(IDC_HTTPDTEMPDISABLELOGIN, OnDataChange)
	ON_BN_CLICKED(IDC_HTTPDINTRUDERDETECTION, OnDataChange)
	ON_BN_CLICKED(IDC_TMPLBROWSE, OnBnClickedTmplbrowse)
END_MESSAGE_MAP()

BOOL CPPgHTTPD::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	httpdPassEdit.SetLimitText(12);
	httpdPassLowEdit.SetLimitText(12);
	httpdPortEdit.SetLimitText(6);
	tmplPathEdit.SetLimitText(MAX_PATH);
	loginAttemptsAllowedEdit.SetLimitText(2);
	tempDisableLoginEdit.SetLimitText(2);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgHTTPD::LoadSettings(void)
{	
	httpdPass = HIDDEN_PASSWORD;
	httpdPassLow = HIDDEN_PASSWORD;
	httpdPort.Format(_T("%d"), app_prefs->GetWSPort());
	
	tmplPath = app_prefs->GetTemplate();	//netwolf
	httpdEnabled = app_prefs->GetWSIsEnabled();
	httpdEnabledLow = app_prefs->GetWSIsLowUserEnabled();

	//Added by Johnny-B 
	httpdIntruderDetectEnabled = app_prefs->IsWSIntruderDetectionEnabled();

	tempDisableLogin.Format(_T("%i"), app_prefs->GetWSTempDisableLogin());
	
	loginAttemptsAllowed.Format(_T("%i"), app_prefs->GetWSLoginAttemptsAllowed());	
	//End Johnny-B

	UpdateData(FALSE);

	OnEnChangeHTTPDEnabled();

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgHTTPD::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);
		
		if(httpdPass != HIDDEN_PASSWORD)
			app_prefs->SetWSPass(httpdPass);

		if(httpdPassLow != HIDDEN_PASSWORD)
			app_prefs->SetWSLowPass(httpdPassLow);

		uint16 oldPort = app_prefs->GetWSPort();
		uint16 newPort = _tstoi(httpdPort);
		if (newPort != oldPort) {
			app_prefs->SetWSPort(newPort);
			theApp.webserver->RestartServer();
		}
		app_prefs->SetWSIsEnabled(httpdEnabled);
		app_prefs->SetWSIsLowUserEnabled(httpdEnabledLow);
		
		app_prefs->SetTemplate(tmplPath);

		//Added by Johnny-B
		app_prefs->SetWSIntruderDetectionEnabled(httpdIntruderDetectEnabled);

		int t = _tstoi(tempDisableLogin);
		if (t > 60) {
			app_prefs->SetWSTempDisableLogin(60);
			tempDisableLogin.Format(_T("%i"), 60);			
		} else if (t < 5 && t != 0) {
			app_prefs->SetWSTempDisableLogin(5);
			tempDisableLogin.Format(_T("%i"), 5);			
		} else {
			app_prefs->SetWSTempDisableLogin(t);
		}

		int a = _tstoi(loginAttemptsAllowed);
		if (a > 5) {
			app_prefs->SetWSLoginAttemptsAllowed(5);
			loginAttemptsAllowed.Format(_T("%i"), 5);			
		} else if (a < 2) {
			app_prefs->SetWSLoginAttemptsAllowed(2);
			loginAttemptsAllowed.Format(_T("%i"), 2);			
		}else{
			app_prefs->SetWSLoginAttemptsAllowed(a);
		}
		//End Johnny-B

		UpdateData(FALSE);

		theApp.webserver->StartServer();

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgHTTPD::Localize(void)
{
	if(::IsWindow(m_hWnd)){
		SetWindowText(GetResString(IDS_PW_HTTPD));
		adminPassDesc = GetResString(IDS_HTTPD_PASS);
		portDesc = GetResString(IDS_PORT);
		httpdEnabledCheck.SetWindowText(GetResString(IDS_ENABLED));
		httpdReloadTmplButton.SetWindowText(GetResString(IDS_HTTPD_RELOAD_TMPL));

		lowUserPassDesc = GetResString(IDS_HTTPD_PASS);		
		generalDesc = GetResString(IDS_PW_GENERAL);

		adminDesc = GetResString(IDS_WEB_ADMIN);
		lowUserDesc = GetResString(IDS_WEB_LOWUSER);		
		httpdEnabledLowCheck.SetWindowText(GetResString(IDS_ENABLED));

		intruderDesc = GetResString(IDS_INTR);
		intruderDetectionCheck.SetWindowText(GetResString(IDS_ENABLED));
		intrLoginDesc = GetResString(IDS_INTR_LOGIN);
		intrTimeDesc = GetResString(IDS_INTR_TIME);
		intrDisableDesc = GetResString(IDS_INTR_DISABLE);

		UpdateData(FALSE);
	}
}

void CPPgHTTPD::OnEnChangeHTTPDEnabled()
{
	UpdateData(TRUE);

	httpdPassEdit.EnableWindow(httpdEnabled);	
	httpdPortEdit.EnableWindow(httpdEnabled);	
	httpdReloadTmplButton.EnableWindow(httpdEnabled); // EC
	httpdEnabledLowCheck.EnableWindow(httpdEnabled);
	httpdPassLowEdit.EnableWindow(httpdEnabled);
	intruderDetectionCheck.EnableWindow(httpdEnabled);
	tempDisableLoginEdit.EnableWindow(httpdEnabled);
	loginAttemptsAllowedEdit.EnableWindow(httpdEnabled);
	tmplPathEdit.EnableWindow(httpdEnabled);
	tmplBrowseButton.EnableWindow(httpdEnabled);

	SetModified();
}

void CPPgHTTPD::OnReloadTemplates()
{
	UpdateData(TRUE);
	app_prefs->SetTemplate(tmplPath);
	theApp.webserver->ReloadTemplates();	
}

void CPPgHTTPD::OnBnClickedTmplbrowse()
{	
	if((tmplPath = DialogBrowseFile((GetResString(IDS_TEMPLATE) + _T(" (*.tmpl)|*.tmpl||")))))
	{
		if(tmplPath != "")
		{
			UpdateData(FALSE);
			SetModified();
		}
	}

}