//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "uploadlistctrl.h"
#include "downloadlistctrl.h"
#include "queuelistctrl.h"
#include "infolistctrl.h"
#include "queuelistctrl.h"
#include "rollupctrl.h"
#include "ResizableLib\ResizableDialog.h"
#include "ToolTips\PPToolTip.h"

#define IDC_DOWNLOADLIST 124
#define IDC_UPLOADLIST	 125
#define IDC_QUEUELIST	 126

// CTransferWnd dialog

class CTransferWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CTransferWnd)

public:
	CTransferWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTransferWnd();
	void	Localize();
// Dialog Data
	enum { IDD = IDD_TRANSFER };
	long 	GetDetailColumnWidth()		//Cax2
	{
		return infolistctrl.GetColumn();
	}
	
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult);
	void UpdateToolTips(void);
	int GetItemUnderMouse(CListCtrl* ctrl);
	DECLARE_MESSAGE_MAP()

private:
//	CString m_strToolTip;
	int m_iOldToolTipItemDown;
	int m_iOldToolTipItemUp;
	int m_iOldToolTipItemQueue;
	bool m_bFirstShow;

public:
	CDownloadListCtrl downloadlistctrl;
	CQueueListCtrl queuelistctrl;
	UINT m_nActiveWnd;
	
	CUploadListCtrl uploadlistctrl;
	CInfoListCtrl infolistctrl;
	CRollupCtrl rollupctrl;
	//CToolTipCtrl m_ttip;
	CPPToolTip m_ttip;
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	void UpdateDownloadHeader();
	void UpdateUploadHeader();
	void UpdateInfoHeader();
	void InitRollupItemHeights();
	void SafeRollupItemHeights();
	void SwitchUploadList();
	afx_msg void OnDestroy();	// eklmn: bugfix(00): resource cleanup due to CResizableDialog

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
};
